Attribute VB_Name = "mOpenSave"
Option Explicit

Private Type OPENFILENAME
        lStructSize As Long
        hwndOwner As Long
        hInstance As Long
        lpstrFilter As String
        lpstrCustomFilter As String
        nMaxCustFilter As Long
        nFilterIndex As Long
        lpstrFile As String
        nMaxFile As Long
        lpstrFileTitle As String
        nMaxFileTitle As Long
        lpstrInitialDir As String
        lpstrTitle As String
        flags As Long
        nFileOffset As Integer
        nFileExtension As Integer
        lpstrDefExt As String
        lCustData As Long
        lpfnHook As Long
        lpTemplateName As String
End Type

Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Const OFN_CREATEPROMPT = &H2000
Private Const OFN_EXPLORER = &H80000                         '  new look commdlg
Private Const OFN_FILEMUSTEXIST = &H1000
Private Const OFN_LONGNAMES = &H200000                       '  force long names for 3.x modules
Private Const OFN_OVERWRITEPROMPT = &H2
Private Const OFS_MAXPATHNAME = 128
Private Const MAX_PATH = 256

Public Function VBGetOpenFileName(ByVal hOwner As Long, Optional sFileName As String, Optional sTitle As String, Optional sFilter As String) As String
    Dim ofn As OPENFILENAME
    Dim i As Integer
    Dim sTemp As String
    sTemp = sFilter
    With ofn
        .lStructSize = Len(ofn)
        .hwndOwner = hOwner
        .flags = OFN_FILEMUSTEXIST
        .lpstrFile = Left(sFileName & String(MAX_PATH, 0), MAX_PATH)
        .lpstrFileTitle = String(MAX_PATH, 0)
        .lpstrTitle = sTitle
        For i = 1 To Len(sTemp)
            If Mid(sTemp, i, 1) = "|" Then Mid(sTemp, i, 1) = Chr(0)
        Next i
        sTemp = sTemp & String(2, 0)
        .lpstrFilter = sTemp
        .nMaxFileTitle = MAX_PATH
        .nMaxFile = MAX_PATH
        .nFilterIndex = 1
        .lpstrInitialDir = App.Path & Chr(0)
    End With
    If GetOpenFileName(ofn) Then
       VBGetOpenFileName = TrimNull(ofn.lpstrFile)
    End If
End Function

Public Function VBGetSaveFileName(ByVal hOwner As Long, Optional sFileName As String, Optional sTitle As String, Optional sFilter As String) As String
    Dim ofn As OPENFILENAME
    Dim i As Integer
    Dim sTemp As String
    sTemp = sFilter
    With ofn
        .lStructSize = Len(ofn)
        .hwndOwner = hOwner
        .flags = OFN_OVERWRITEPROMPT
        .lpstrFile = Left(sFileName & String(MAX_PATH, 0), MAX_PATH)
        .lpstrFileTitle = String(MAX_PATH, 0)
        .lpstrTitle = sTitle
        For i = 1 To Len(sTemp)
            If Mid(sTemp, i, 1) = "|" Then Mid(sTemp, i, 1) = Chr(0)
        Next i
        sTemp = sTemp & String(2, 0)
        .lpstrFilter = sTemp
        .nMaxFileTitle = MAX_PATH
        .nMaxFile = MAX_PATH
        .nFilterIndex = 1
        .lpstrInitialDir = App.Path & Chr(0)
    End With
    If GetSaveFileName(ofn) Then
       VBGetSaveFileName = TrimNull(ofn.lpstrFile)
    End If
End Function

Private Function TrimNull(ByVal s As String) As String
   Dim nPos As Long
   nPos = InStr(1, s, Chr(0))
   If nPos Then
      TrimNull = Left(s, nPos - 1)
   Else
      TrimNull = s
   End If
End Function
